#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#define X_OFFSET 0
#define Y_OFFSET 0

// d0 ??????????????
// e1 ??
// e2 ??
// E6 Reset Scaling
// E7 Set scaling
// E8 Set resolution
// E9 Determine status
// Ea Set stream modus
// eb read data
// ec reset wrap mode
// ee set wrap mode
// f0 set remote mode
// f2 identify unit
// f3 set sample rate
// f4 enable
// f5 disable
// f5 set standard
// fe resend
// ff reset

int write_ack(int fd, unsigned char w) {
   unsigned char c;
   write(fd, &w, 1); 
   printf("<< %02x", (int)w);
   read(fd, &c, 1);
   if(c == 0xfa)
     printf(" ACK");
   else
     printf(" %02x", (int) c);
   printf("\n");
   fflush(stdout);
}

void main() {
   unsigned char seq[100];
   unsigned int x, y, 
                x_off = X_OFFSET,
                y_off = Y_OFFSET;
   int i, n, j;
   unsigned char w;
   int fd;
   fd = open("/dev/psaux", O_RDWR/*|O_NONBLOCK*/);
      
#define READ(a) printf(">> "); for(i=0; i < a; ) {\
      if (n=read(fd, &seq[i], 1) > 0) {\
         printf("%02x ", (int)seq[i]);i+=n;fflush(stdout);} else \
         if(errno!=EAGAIN) break;else usleep(100);};printf("\n");
/*
   write_ack(fd, 0xf5);
   write_ack(fd, 0xf4);
   write_ack(fd, 0xe1);
   write_ack(fd, 0xe9);   READ(1);
   write_ack(fd, 0xff);   READ(2);
   write_ack(fd, 0xf3);
   write_ack(fd, 100);
   write_ack(fd, 0xe8);
   write_ack(fd, 3);
   write_ack(fd, 0xf6);
   write_ack(fd, 0xf4);
*/
   write_ack(fd, 0xf5);
   write_ack(fd, 0xf4);
   write_ack(fd, 0xff);   READ(2);
   write_ack(fd, 0xe6);
   write_ack(fd, 0xf3);
   write_ack(fd, 0x28);
   
   write_ack(fd, 0xe8);
   write_ack(fd, 0x3);
  
   write_ack(fd, 0xe8); 
   write_ack(fd, 0x7);

   write_ack(fd, 0xf4);
   write_ack(fd, 0xf4);
   write_ack(fd, 0xf4);
   
   while(1) {
      READ(3);
   }
}
